/*
$Id: parser_typen.h,v 1.11 2005/01/19 10:24:21 mah Exp $
$Log: parser_typen.h,v $
Revision 1.11  2005/01/19 10:24:21  mah
New command-line option --cvs-status to add `cvs status' information.
This information was always enabled before but this was too annoying if there
is no cvs information available.

Revision 1.10  2001/07/28 11:15:56  cb
added --parse-only option

Revision 1.9  2001/05/17 12:12:20  dirkl
- added command-line option --no-translation

Revision 1.8  2001/01/21 17:22:58  sbeyer

added additional option '--hdl-comments'

Revision 1.7  2001/01/11 16:16:50  sbeyer

added command line support for pvs_path

Revision 1.6  2001/01/11 10:08:49  sbeyer

added parameter parse_verbose

*/
#ifndef parser_typen_h
#define parser_typen_h

#ifdef __cplusplus
extern "C" {
#endif

extern const char * const typname[];
extern const char * const boolstring[];
extern const char * const token_string[];
extern const char * const subtyp_string[];
extern char *pvs_path;

extern int parameter_gdlausgabe;
extern int parameter_parsetreeausgabe;
extern int parameter_verbose;
extern int parameter_parse_only;
extern int parameter_parse_verbose;
extern int parameter_hdl_comment;
extern int parameter_speicherausgabe;
extern int parameter_no_translation;
extern int parameter_cvs_status;
extern int freigegebener_speicher;
extern int allokierter_speicher;

  /* Konstanten fuer die Knotentypen */

#define adt_or_theories     0
#define adt_or_theory       1
#define theory_or_datatype  2
#define theory              3
#define datatype            4
#define adtcase_plus        5
#define adtcase             6
#define constructor         7
#define idopstype_expr_list 8
#define theoryformals       9
#define theoryformal_list   10
#define theoryformal        11
#define theoryformaldecl    12
#define exporting           13
#define exportings          14
#define expname_list        15
#define expname             16
#define exportingmods       17
#define assumingpart        18
#define assumings           19
#define assuming            20
#define pdformals_stern     21
#define theory_part         22
#define theory_elt          23
#define importing           24
#define modname_list        25
#define judgement           26
#define jdecl_list          27
#define jdecl               28
#define ename               29
#define conversion          30
#define ename_list          31
#define adformals           32
#define adformal            33
#define assuming_decl       34
#define theory_decl         35
#define lib_decl            36
#define mod_decl            37
#define type_decl           38
#define type_keyword        39
#define type_def            40
#define var_decl            41
#define const_decl          42
#define const_value         43
#define def_decl            44
#define ind_decl            45
#define assumption          46
#define formula_decl        47
#define type_expr           48
#define type_expr_sans_name 49
#define comp_type_expr      50
#define dep_type_expr_list  51
#define recordtype          52
#define field_decls_list    53
#define field_decls         54
#define fun_array           55
#define dep_type_expr       56
#define funarg              57
#define expr                58
#define cond_case_list      59
#define selection_list      60
#define bind                61
#define bind_list           62
#define elseif_plus         63
#define expr_leerlist       64
#define expr_list           65
#define assignment_list     66
#define set_expr            67
#define cond_case           68
#define lambda_body         69
#define lambda_formals      70
#define lambda_formal       71
#define set_formals         72
#define set_formal          73
#define selection           74
#define assignment          75
#define assign_arg_plus     76
#define assign_arg          77
#define table_expr          78
#define col_heading         79
#define expr_else_plus      80
#define expr_else_plus2     81
#define table_entries       82
#define table_entry         83
#define simplebind_list     84
#define simplebind          85
#define pdformals_plus      86
#define modnames            87
#define modname             88
#define mappings            89
#define mapdecl_list        90
#define mapdecl             91
#define typedecl_or_constdecl 92
#define idops               93
#define idop                94
#define ids                 95
#define typeid              96
#define typeids             97
#define name_token          98
#define opsym               99
#define actuals             100
#define actual_list         101
#define actual              102
#define formulaname         103
#define ID_token            104
#define NUMBER_token        105
#define STRING_token        106

#define no_subtyp           418

#ifdef __cplusplus
}
#endif

#endif // parser_typen_h

